'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Surface = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Surface = exports.Surface = function (_React$Component) {
  _inherits(Surface, _React$Component);

  function Surface(props) {
    _classCallCheck(this, Surface);

    var _this = _possibleConstructorReturn(this, (Surface.__proto__ || Object.getPrototypeOf(Surface)).call(this, props));

    _this.state = {
      width: window.innerWidth,
      height: window.innerHeight
    };

    _this.reRenderChildrenComponent = _this.reRenderChildrenComponent.bind(_this);
    return _this;
  }

  _createClass(Surface, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      window.addEventListener('resize', function () {
        _this2.setState({ width: window.innerWidth, height: window.innerHeight });
      });
    }
  }, {
    key: 'reRenderChildrenComponent',
    value: function reRenderChildrenComponent() {
      var width = this.state.width;
      var height = this.state.height;

      if (_lodash2.default.isArray(this.props.children)) return _lodash2.default.map(this.props.children, function (child, i) {
        return _react2.default.cloneElement(child, { width: width, height: height, key: i });
      });else {
        return _react2.default.cloneElement(this.props.children, { width: width, height: height });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        this.reRenderChildrenComponent()
      );
    }
  }]);

  return Surface;
}(_react2.default.Component);